package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysUser;
import cn.estsh.i3plus.pojo.platform.bean.SysUserInfo;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 用户服务
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-25 16:21
 * @Modify :
 **/
public interface ISysUserInfoService {


    /**
     * 新增数据
     * @param userInfo
     * @return
     */
    @ApiOperation(value = "新增用户",notes = "新增一个用户信息")
    SysUserInfo insertSysUserInfo(SysUserInfo userInfo);

    /**
     * 修改数据
     * @param userInfo
     */
    @ApiOperation(value = "修改用户",notes = "修改一个用户信息")
    void updateSysUserInfo(SysUserInfo userInfo);

    /**
     * 刷新 用户部门关系
     * @param userInfoId
     * @param departmentId
     * @param userName
     */
    void refreshRefUserDepartment(String userInfoId, String[] departmentId , String userName);

    /**
     * 刷新用户岗位信息
     * @param userInfoId
     * @param positionIds
     * @param userName
     */
    void refreshRefUserPosition(String userInfoId, String[] positionIds , String userName);

    /**
     * 刷新用户组织信息
     * @param userInfoId
     * @param organizeId
     * @param userName
     */
    void refreshRefUserOrganize(String userInfoId, String organizeId , String userName);

    /**
     * 根据Key 删除数据
     * @param id
     */
    @ApiOperation(value = "删除用户",notes = "根据UserInfoId 删除用户信息")
    void deleteSysUserInfoById(String id);

    /**
     * 根据id批量删除岗位
     * @param ids id数组
     * @return
     */
    @ApiOperation(value = "删除用户-批量",notes = "根据UserInfoId 批量删除用户信息")
    void deleteSysUserInfoByIds(String[] ids);

    /**
     * 根据Key 数据
     * @param id
     * @return
     */
    @ApiOperation(value = "查询用户信息",notes = "根据 UserInfoId查询用户信息")
    SysUserInfo getSysUserInfoById(Long id);

    /**
     * 查询所有数据
     * @return
     */
    @ApiOperation(value = "查询用户信息",notes = "查询所有用户信息")
    List listSysUserInfo();

    /**
     * 复杂查询
     * @param userInfo
     * @param pager
     * @return
     */
    @ApiOperation(value = "查询用户信息",notes = "根据复杂查询条件查询用户信息(分页信息)")
    ListPager<SysUserInfo> querySysUserInfo(SysUserInfo userInfo, Pager pager);

}
